﻿using System;
using Grasshopper.Kernel;
using System.Threading.Tasks;

namespace Draft
{
    public class Test : GH_Component
    {
        private int counter;

        public Test()
          : base("Test", "test", "Just a test", "Draft", "Test")
        {
        }

        protected override void RegisterInputParams(GH_Component.GH_InputParamManager pManager)
        {
        }

        protected override void RegisterOutputParams(GH_Component.GH_OutputParamManager pManager)
        {
            pManager.AddIntegerParameter("Counter", "counter", "Increases every time the instance is solved", GH_ParamAccess.item);
        }

        private void expireSolutionAfterDelay(IGH_DataAccess DA)
        {
            Task.Delay(500).ContinueWith((task) => {
                ExpireSolution(true);
            });
        }

        protected override void SolveInstance(IGH_DataAccess DA)
        {
            DA.SetData(0, counter);
            expireSolutionAfterDelay(DA);
            counter++;
        }

        protected override System.Drawing.Bitmap Icon
        {
            get
            {
                //You can add image files to your project resources and access them like this:
                // return Resources.IconForThisComponent;
                return null;
            }
        }

        public override Guid ComponentGuid
        {
            get { return new Guid("32960acc-134d-4cec-842a-e8cdbaa6b844"); }
        }
    }
}
